// ALISP engine v0.4.3b
// ALISP is dedicated to Enota, the girl i'll never forget
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
const
  maxListSize = maxInt div 16;


type
  PIntegerList = ^TIntegerList;
  TIntegerList = packed array [0..maxListSize-1] of Integer;

  //EListError = class (Exception);

  TSortedIntList = class (TObject)
  private
    fList: PIntegerList;
    fCount: Integer;
    fCapacity: Integer;

  protected
    function Get (index: Integer): Integer;
    procedure Grow ();
    procedure SetCapacity (newCapacity: Integer);
    procedure Insert (index, item: Integer);

  public
    destructor Destroy (); override;
    function Add (item: Integer): Integer;
    procedure Clear ();
    procedure Delete (index: Integer);
    function Extract (item: Integer): Integer;
    function IndexOf (item: Integer): Integer;
    function Find (item: Integer; out index: Integer): Boolean;

    property Capacity: Integer read fCapacity write SetCapacity;
    property Count: Integer read fCount;
    property Items [index: Integer]: Integer read Get; default;
    property List: PIntegerList read fList;
  end;
