// ALISP engine v0.4.3b
// ALISP is dedicated to Enota, the girl i'll never forget
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
function ALPIncr (n: Integer): Integer;
var
  nn, d: Integer;
begin
  if al_CDR[n].vi <> al_Nil then
  begin
    result := ALEval(al_CAR[al_CDR[n].vi]);
    if al_BreakFlag <> ALBREAK_NONE then exit;
    if ALGetAtomType(result) <> DT_INTEGER then begin result := ALThrowError('INCR: integer expected', al_CAR[al_CDR[n].vi]); exit; end;
    d := al_CDR[result].vi;
  end
  else d := 1;
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: result := ALNewIntAtom(al_CDR[nn].vi+d);
    DT_FLOAT: result := ALNewFloatAtom(al_CDR[nn].vf+d);
    else result := ALThrowError('INCR: invalid arg type', n);
  end;
end;

function ALPDecr (n: Integer): Integer;
var
  nn, d: Integer;
begin
  if al_CDR[n].vi <> al_Nil then
  begin
    result := ALEval(al_CAR[al_CDR[n].vi]);
    if al_BreakFlag <> ALBREAK_NONE then exit;
    if ALGetAtomType(result) <> DT_INTEGER then begin result := ALThrowError('DECR: integer expected', al_CAR[al_CDR[n].vi]); exit; end;
    d := al_CDR[result].vi;
  end
  else d := 1;
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: result := ALNewIntAtom(al_CDR[nn].vi-d);
    DT_FLOAT: result := ALNewFloatAtom(al_CDR[nn].vf-d);
    else result := ALThrowError('DECR: invalid arg type', n);
  end;
end;

function ALPIncVar (n: Integer): Integer;
var
  nn, d: Integer;
begin
  nn := al_CAR[n];
  if ALGetAtomType(nn) <> DT_STRING then begin result := ALThrowError('INC-V: identifier expected', nn); exit; end;
  if al_CDR[n].vi <> al_Nil then
  begin
    result := ALEval(al_CAR[al_CDR[n].vi]);
    if al_BreakFlag <> ALBREAK_NONE then exit;
    if ALGetAtomType(result) <> DT_INTEGER then begin result := ALThrowError('INC-V: integer expected', al_CAR[al_CDR[n].vi]); exit; end;
    d := al_CDR[result].vi;
  end
  else d := 1;
  nn := ALFindSymbolEx(al_StringPool[al_CDR[nn].vi], al_CDR[nn].vi);
  if nn = al_Nil then begin result := ALThrowError('INC-V: undefined variable', n); exit; end;
  n := al_CDR[nn].vi;
  case ALGetAtomType(n) of
    DT_INTEGER: al_CDR[nn].vi := ALNewIntAtom(al_CDR[n].vi+d);
    DT_FLOAT: al_CDR[nn].vi := ALNewFloatAtom(al_CDR[n].vf+d);
    else result := ALThrowError('INC-V: invalid variable type'); exit;
  end;
  result := al_CDR[nn].vi;
end;

function ALPDecVar (n: Integer): Integer;
var
  nn, d: Integer;
begin
  nn := al_CAR[n];
  if ALGetAtomType(nn) <> DT_STRING then begin result := ALThrowError('DEC-V: identifier expected', nn); exit; end;
  if al_CDR[n].vi <> al_Nil then
  begin
    result := ALEval(al_CAR[al_CDR[n].vi]);
    if al_BreakFlag <> ALBREAK_NONE then exit;
    if ALGetAtomType(result) <> DT_INTEGER then begin result := ALThrowError('DEC-V: integer expected', al_CAR[al_CDR[n].vi]); exit; end;
    d := al_CDR[result].vi;
  end
  else d := 1;
  nn := ALFindSymbolEx(al_StringPool[al_CDR[nn].vi], al_CDR[nn].vi);
  if nn = al_Nil then begin result := ALThrowError('DEC-V: undefined variable', n); exit; end;
  n := al_CDR[nn].vi;
  case ALGetAtomType(n) of
    DT_INTEGER: al_CDR[nn].vi := ALNewIntAtom(al_CDR[n].vi-d);
    DT_FLOAT: al_CDR[nn].vi := ALNewFloatAtom(al_CDR[n].vf-d);
    else result := ALThrowError('DEC-V: invalid variable type: '+IntToStr(ALGetAtomType(n))); exit;
  end;
  result := al_CDR[nn].vi;
end;

function ALPPostIncVar (n: Integer): Integer;
var
  nn, d: Integer;
begin
  nn := al_CAR[n];
  if ALGetAtomType(nn) <> DT_STRING then begin result := ALThrowError('POST-INC-V: identifier expected', nn); exit; end;
  if al_CDR[n].vi <> al_Nil then
  begin
    result := ALEval(al_CAR[al_CDR[n].vi]);
    if al_BreakFlag <> ALBREAK_NONE then exit;
    if ALGetAtomType(result) <> DT_INTEGER then begin result := ALThrowError('POST-INC-V: integer expected', al_CAR[al_CDR[n].vi]); exit; end;
    d := al_CDR[result].vi;
  end
  else d := 1;
  nn := ALFindSymbolEx(al_StringPool[al_CDR[nn].vi], al_CDR[nn].vi);
  if nn = al_Nil then begin result := ALThrowError('POST-INC-V: undefined variable', n); exit; end;
  n := al_CDR[nn].vi; result := n;
  case ALGetAtomType(n) of
    DT_INTEGER: al_CDR[nn].vi := ALNewIntAtom(al_CDR[n].vi+d);
    DT_FLOAT: al_CDR[nn].vi := ALNewFloatAtom(al_CDR[n].vf+d);
    else result := ALThrowError('POST-INC-V: invalid variable type');
  end;
end;

function ALPPostDecVar (n: Integer): Integer;
var
  nn, d: Integer;
begin
  nn := al_CAR[n];
  if ALGetAtomType(nn) <> DT_STRING then begin result := ALThrowError('POST-DEC-V: identifier expected', nn); exit; end;
  if al_CDR[n].vi <> al_Nil then
  begin
    result := ALEval(al_CAR[al_CDR[n].vi]);
    if al_BreakFlag <> ALBREAK_NONE then exit;
    if ALGetAtomType(result) <> DT_INTEGER then begin result := ALThrowError('POST-DEC-V: integer expected', al_CAR[al_CDR[n].vi]); exit; end;
    d := al_CDR[result].vi;
  end
  else d := 1;
  nn := ALFindSymbolEx(al_StringPool[al_CDR[nn].vi], al_CDR[nn].vi);
  if nn = al_Nil then begin result := ALThrowError('POST-DEC-V: undefined variable', n); exit; end;
  n := al_CDR[nn].vi; result := n;
  case ALGetAtomType(n) of
    DT_INTEGER: al_CDR[nn].vi := ALNewIntAtom(al_CDR[n].vi-d);
    DT_FLOAT: al_CDR[nn].vi := ALNewFloatAtom(al_CDR[n].vf-d);
    else result := ALThrowError('POST-DEC-V: invalid variable type');
  end;
end;

function ALPBitNot (n: Integer): Integer;
var
  nn: Integer;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: result := ALNewIntAtom(not (al_CDR[nn].vi));
    else result := ALThrowError('~: invalid arg type', n);
  end;
end;

function ALPRnd (n: Integer): Integer;
var
  nn: Integer;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: result := ALNewIntAtom(Random(al_CDR[nn].vi));
    else result := ALThrowError('RND: invalid arg type', n);
  end;
end;

function ALPRandomize (n: Integer): Integer;
var
  nn: Integer;
begin
  result := ALTrue();
  if n = al_Nil then Randomize()
  else
  begin
    nn := al_CAR[n];
    case ALGetAtomType(nn) of
      DT_INTEGER: randSeed := al_CDR[nn].vi;
      else result := ALThrowError('RANDOMIZE: invalid arg type', n);
    end;
  end;
end;

function ALPAbs (n: Integer): Integer;
var
  nn: Integer;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: result := ALNewIntAtom(abs(al_CDR[nn].vi));
    DT_FLOAT: result := ALNewFloatAtom(abs(al_CDR[nn].vf));
    else result := ALThrowError('ABS: invalid arg type', n);
  end;
end;

function ALPNeg (n: Integer): Integer;
var
  nn: Integer;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: result := ALNewIntAtom(-(al_CDR[nn].vi));
    DT_FLOAT: result := ALNewFloatAtom(-(al_CDR[nn].vf));
    else result := ALThrowError('NEG: invalid arg type', n);
  end;
end;

function ALPSqr (n: Integer): Integer;
var
  nn: Integer;
  fn: TALFloat;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: result := ALNewIntAtom(al_CDR[nn].vi*al_CDR[nn].vi);
    DT_FLOAT:
      begin
        fn := al_CDR[nn].vf;
        try
          result := ALNewFloatAtom(fn*fn);
        except
          result := ALThrowError('SQR: floating error', n);
        end;
      end;
    else result := ALThrowError('SQR: invalid arg type', n);
  end;
end;

function ALPSqrt (n: Integer): Integer;
var
  nn: Integer;
  fn: TALFloat;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: fn := al_CDR[nn].vi;
    DT_FLOAT: fn := al_CDR[nn].vf;
    else begin result := ALThrowError('SQRT: invalid arg type', n); exit; end;
  end;
  try
    result := ALNewFloatAtom(sqrt(fn));
  except
    result := ALThrowError('SQRT: floating error', n);
  end;
end;

function ALPSign (n: Integer): Integer;
var
  nn: Integer;
  fn: TALFloat;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER:
      begin
        nn := al_CDR[nn].vi;
        if nn < 0 then nn := -1 else if nn > 0 then nn := 1;
        result := ALNewIntAtom(nn);
      end;
    DT_FLOAT:
      begin
        fn := al_CDR[nn].vf;
        if fn < 0 then nn := -1 else if fn > 0 then nn := 1 else nn := 0;
        result := ALNewIntAtom(nn);
      end;
    else result := ALThrowError('SIGN: invalid arg type', n);
  end;
end;

function ALPIsNeg (n: Integer): Integer;
var
  nn: Integer;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER:
      begin
        if al_CDR[nn].vi < 0 then result := al_strue else result := al_sfalse;
      end;
    DT_FLOAT:
      begin
        if al_CDR[nn].vf < 0 then result := al_strue else result := al_sfalse;
      end;
    else result := ALThrowError('NEG?: invalid arg type', n);
  end;
end;

function ALPIsPos (n: Integer): Integer;
var
  nn: Integer;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER:
      begin
        if al_CDR[nn].vi > 0 then result := al_strue else result := al_sfalse;
      end;
    DT_FLOAT:
      begin
        if al_CDR[nn].vf > 0 then result := al_strue else result := al_sfalse;
      end;
    else result := ALThrowError('POS?: invalid arg type', n);
  end;
end;

function ALPIsZero (n: Integer): Integer;
var
  nn: Integer;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER:
      begin
        if al_CDR[nn].vi = 0 then result := al_strue else result := al_sfalse;
      end;
    DT_FLOAT:
      begin
        if al_CDR[nn].vf = 0 then result := al_strue else result := al_sfalse;
      end;
    else result := ALThrowError('ZERO?: invalid arg type', n);
  end;
end;

function ALPIsNotZero (n: Integer): Integer;
var
  nn: Integer;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER:
      begin
        if al_CDR[nn].vi <> 0 then result := al_strue else result := al_sfalse;
      end;
    DT_FLOAT:
      begin
        if al_CDR[nn].vf <> 0 then result := al_strue else result := al_sfalse;
      end;
    else result := ALThrowError('NOT-ZERO?: invalid arg type', n);
  end;
end;

function ALPToInt (n: Integer): Integer;
var
  nn: Integer;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: result := nn;
    DT_FLOAT: result := ALNewIntAtom(round(al_CDR[nn].vf));
    DT_STRING:
      begin
        if ExtStr2Int(al_StringPool[al_CDR[nn].vi], nn) then result := ALNewIntAtom(nn)
        else result := ALThrowError('TOINT: invalid string', al_CAR[n]);
      end;
    else result := ALThrowError('TOINT: invalid arg type', n);
  end;
end;

function ALPToFloat (n: Integer): Integer;
var
  nn, i: Integer;
  fn: TALFloat;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: result := ALNewFloatAtom(al_CDR[nn].vi);
    DT_FLOAT: result := nn;
    DT_STRING:
      begin
        if ExtStr2Int(al_StringPool[al_CDR[nn].vi], i) then result := ALNewFloatAtom(i)
        else
        begin
          Val(al_StringPool[al_CDR[nn].vi], fn, nn);
          if nn = 0 then result := ALNewFloatAtom(fn)
          else result := ALThrowError('TOFLOAT: invalid string', al_CAR[n]);
        end;
      end;
    else result := ALThrowError('TOFLOAT: invalid arg type', n);
  end;
end;

function ALPToNumber (n: Integer): Integer;
var
  nn: Integer;
  fn: TALFloat;
  s: string;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: result := nn;
    DT_FLOAT: result := nn;
    DT_STRING:
      begin
        s := al_StringPool[al_CDR[nn].vi];
        if ExtStr2Int(s, nn) then result := ALNewIntAtom(nn)
        else
        begin
          Val(s, fn, nn);
          if nn = 0 then result := ALNewFloatAtom(fn)
          else result := ALThrowError('TONUMBER: invalid string', al_CAR[n]);
        end;
      end;
    else result := ALThrowError('TONUMBER: invalid arg type', n);
  end;
end;

function ALPToStr (n: Integer): Integer;
var
  nn: Integer;
begin
  nn := al_CAR[n];
  case ALGetAtomType(nn) of
    DT_INTEGER: result := ALNewStrAtom(IntToStr(al_CDR[nn].vi));
    DT_FLOAT: result := ALNewStrAtom(ALGetAtomStr(nn));
    DT_STRING: result := nn;
    else result := ALThrowError('TOSTR: invalid arg type', n);
  end;
end;


type
  TLispMathOp =
    (_plus, _minus, _mul, _idiv, _mod, _div, _max, _min, _band, _bor, _bxor);

function LispDoMath (n: Integer; op: TLispMathOp): Integer;
var
  typ, nn, c: Integer;
  flt: Boolean;
  ni, ai: Integer;
  nf, af: TALFloat;
  first: Boolean;
begin
  ni := 0; nf := 0; af := 0; ai := 0; flt := false;

  try
    first := true; c := n;
    while c <> al_Nil do
    begin
      nn := al_CAR[c];
      typ := ALGetAtomType(nn);
      case typ of
        DT_INTEGER:
          begin
            if flt then af := al_CDR[nn].vi else ai := al_CDR[nn].vi;
          end;
        DT_FLOAT:
          begin
            if not flt then
            begin
              nf := ni;
              flt := true;
            end;
            af := al_CDR[nn].vf;
          end;
        else begin result := ALThrowError('MATH: invalid arg type', n); exit; end;
      end;

      if first then begin ni := ai; nf := af; first := false; end
      else
        case op of
          _plus: if flt then nf := nf+af else ni := ni+ai;
          _minus: if flt then nf := nf-af else ni := ni-ai;
          _mul: if flt then nf := nf*af else ni := ni*ai;
          _div:
            begin
              if not flt then begin nf := ni; af := ai; flt := true; end;
              nf := nf/af;
            end;
          _idiv:
            begin
              if flt then begin result := ALThrowError('MATH: floating operand in IDIV', n); exit; end;
              ni := ni div ai;
            end;
          _mod:
            begin
              if flt then begin result := ALThrowError('MATH: floating operand in MOD', n); exit; end;
              ni := ni mod ai;
            end;
          _min:
            if flt then
            begin
              if af < nf then nf := af;
            end
            else
            begin
              if ai < ni then ni := ai;
            end;
          _max:
            if flt then
            begin
              if af > nf then nf := af;
            end
            else
            begin
              if ai > ni then ni := ai;
            end;
          _band:
            begin
              if flt then begin result := ALThrowError('MATH: floating operand in "&"', n); exit; end;
              ni := ni and ai;
            end;
          _bor:
            begin
              if flt then begin result := ALThrowError('MATH: floating operand in "|"', n); exit; end;
              ni := ni or ai;
            end;
          _bxor:
            begin
              if flt then begin result := ALThrowError('MATH: floating operand in "^"', n); exit; end;
              ni := ni xor ai;
            end;
        end;
      c := al_CDR[c].vi;
    end;
    if flt then result := ALNewFloatAtom(nf) else result := ALNewIntAtom(ni);
  except
    result := ALThrowError('math error', n);
  end;
end;


type
  TLispCompOp =
    (_less, _lessequ, _great, _greatequ, _equ, _notequ,
     _sless, _slessequ, _sgreat, _sgreatequ, _sequ, _snotequ);

function LispDoComp (n: Integer; op: TLispCompOp): Integer;
var
  typ, nn, c: Integer;
  flt: Boolean;
  str: Boolean;
  ni, ai: Integer;
  nf, af: TALFloat;
  ns, as_: Integer;
begin
  ni := 0; nf := 0; af := 0; ai := 0; ns := 0; as_ := 0; flt := false;
  str := false; // shut up the compiler

  try
    c := n; nn := al_CAR[c];
    typ := ALGetAtomType(nn);
    case typ of
      DT_INTEGER: ni := al_CDR[nn].vi;
      DT_FLOAT: begin nf := al_CDR[nn].vf; flt := true; end;
      DT_STRING: begin ns := al_CDR[nn].vi; str := true; end;
      else begin result := ALThrowError('COMP: invalid arg type', n); exit; end;
    end;
    c := al_CDR[c].vi; nn := al_CAR[c];
    typ := ALGetAtomType(nn);
    if str and (typ <> DT_STRING) then
    begin
      result := ALThrowError('COMP: invalid comparison', n);
      exit;
    end;

    if (ord(op) >= ord(_sless)) and not str then
    begin
      result := ALThrowError('COMP: invalid arg type', n);
      exit;
    end;

    case typ of
      DT_INTEGER:
        begin
          if flt then af := al_CDR[nn].vi else ai := al_CDR[nn].vi;
        end;
      DT_FLOAT:
        begin
          if not flt then begin nf := ni; flt := true; end;
          af := al_CDR[nn].vf;
        end;
      DT_STRING: as_ := al_CDR[nn].vi;
      else begin result := ALThrowError('COMP: invalid 2nd arg type', n); exit; end;
    end;

    if ord(op) >= ord(_sless) then
    begin
      as_ := CompareStr(AnsiUpperCase(al_StringPool[ns]), AnsiUpperCase(al_StringPool[as_]));
      op := TLispCompOp(ord(op)-(ord(_sless)-ord(_less)));
    end
    else if str then as_ := {Ansi}CompareStr(al_StringPool[ns], al_StringPool[as_]);

    case op of
      _less:
        if str then flt := (as_ < 0)
        else if flt then flt := (nf < af)
        else flt := (ni < ai);
      _lessequ:
        if str then flt := (as_ <= 0)
        else if flt then flt := (nf <= af)
        else flt := (ni <= ai);
      _great:
        if str then flt := (as_ > 0)
        else if flt then flt := (nf > af)
        else flt := (ni > ai);
      _greatequ:
        if str then flt := (as_ >= 0)
        else if flt then flt := (nf >= af)
        else flt := (ni >= ai);
      _equ:
        if str then flt := (as_ = 0)
        else if flt then flt := (nf = af)
        else flt := (ni = ai);
      _notequ:
        if str then flt := (as_ <> 0)
        else if flt then flt := (nf <> af)
        else flt := (ni <> ai);
    end;
    if flt then result := al_strue else result := al_sfalse;
  except
    result := ALThrowError('COMP: comparison error', n);
  end;
end;


function ALPPlus (n: Integer): Integer;
begin
  result := LispDoMath(n, _plus);
end;

function ALPMinus (n: Integer): Integer;
begin
  result := LispDoMath(n, _minus);
end;

function ALPMul (n: Integer): Integer;
begin
  result := LispDoMath(n, _mul);
end;

function ALPDiv (n: Integer): Integer;
begin
  result := LispDoMath(n, _div);
end;

function ALPIDiv (n: Integer): Integer;
begin
  result := LispDoMath(n, _idiv);
end;

function ALPMod (n: Integer): Integer;
begin
  result := LispDoMath(n, _mod);
end;

function ALPMin (n: Integer): Integer;
begin
  result := LispDoMath(n, _min);
end;

function ALPMax (n: Integer): Integer;
begin
  result := LispDoMath(n, _max);
end;

function ALPBitAnd (n: Integer): Integer;
begin
  result := LispDoMath(n, _band);
end;

function ALPBitOr (n: Integer): Integer;
begin
  result := LispDoMath(n, _bor);
end;

function ALPBitXor (n: Integer): Integer;
begin
  result := LispDoMath(n, _bxor);
end;


function ALPLess (n: Integer): Integer;
begin
  result := LispDoComp(n, _less);
end;

function ALPLessEqu (n: Integer): Integer;
begin
  result := LispDoComp(n, _lessequ);
end;

function ALPGreat (n: Integer): Integer;
begin
  result := LispDoComp(n, _great);
end;

function ALPGreatEqu (n: Integer): Integer;
begin
  result := LispDoComp(n, _greatequ);
end;

function ALPEqu (n: Integer): Integer;
begin
  result := LispDoComp(n, _equ);
end;

function ALPNotEqu (n: Integer): Integer;
begin
  result := LispDoComp(n, _notequ);
end;


function ALPSLess (n: Integer): Integer;
begin
  result := LispDoComp(n, _sless);
end;

function ALPSLessEqu (n: Integer): Integer;
begin
  result := LispDoComp(n, _slessequ);
end;

function ALPSGreat (n: Integer): Integer;
begin
  result := LispDoComp(n, _sgreat);
end;

function ALPSGreatEqu (n: Integer): Integer;
begin
  result := LispDoComp(n, _sgreatequ);
end;

function ALPSEqu (n: Integer): Integer;
begin
  result := LispDoComp(n, _sequ);
end;

function ALPSNotEqu (n: Integer): Integer;
begin
  result := LispDoComp(n, _snotequ);
end;
