// DarkSpecter ZX Spectum Emulator
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
// draw menus
//
unit dspEmuMenuU;

interface

uses
  Windows, Messages,  SysUtils, Classes, lispCon3U,
  dspEmuVarsU, dspVScrU, dspEmuMiscU, dspEmuMouseU;


type
  // ismarked, ismouseon, iscursor
  TMenuColors = array [Boolean, Boolean, Boolean, 0..1] of Byte;


procedure MenuDrawCursor ();

function MenuXY (x, y, wChars, hChars: Integer;
  borderH, borderV: Integer;
  const items: array of string;
  const markedItems: array of Boolean;  // selected items
  currentItem: Integer; // -1: current is "undermouse"
  topItem: Integer; // the first visible item
  itemsInRow, rowWChars: Integer;
  outerFrameC, frameC, backC: Byte;
  const colors: TMenuColors;
  msX, msY: Integer;
  draw: Boolean = true): Integer;
// returns the # of the item under the mouse cursor


implementation


const
  winCursorImg: packed array [0..1, 0..11, 0..7] of Byte = (
   ((2,2,0,0,0,0,0,0),
    (2,1,2,0,0,0,0,0),
    (2,1,1,2,0,0,0,0),
    (2,1,1,1,2,0,0,0),
    (2,1,1,1,1,2,0,0),
    (2,1,1,1,1,1,2,0),
    (2,1,1,1,1,1,1,2),
    (2,1,1,1,1,1,1,2),
    (2,1,1,1,2,2,2,2),
    (2,1,1,2,1,1,2,0),
    (2,2,2,2,1,1,2,0),
    (0,0,0,2,2,2,2,0)),

   ((2,2,0,0,0,0,0,0),
    (2,1,2,2,0,0,0,0),
    (2,1,1,1,2,2,0,0),
    (2,1,1,1,1,1,2,2),
    (2,1,1,1,1,1,1,2),
    (2,1,1,1,2,2,1,2),
    (2,1,1,2,1,1,2,0),
    (2,1,1,2,1,1,2,0),
    (2,2,2,2,2,2,2,0),
    (0,0,0,0,0,0,0,0),
    (0,0,0,0,0,0,0,0),
    (0,0,0,0,0,0,0,0)));


procedure MenuDrawCursor ();
var
  curN: Integer;
begin
  if (emuMouseButtons <> 0) then curN := 1 else curN := 0;
  VDrawCursor(emuMouseX, emuMouseY, 8, 12, winCursorImg[curN]);
end;


function MenuXY (x, y, wChars, hChars: Integer;
  borderH, borderV: Integer;
  const items: array of string;
  const markedItems: array of Boolean;  // selected items
  currentItem: Integer; // -1: current is "undermouse"
  topItem: Integer; // the first visible item
  itemsInRow, rowWChars: Integer;
  outerFrameC, frameC, backC: Byte;
  const colors: TMenuColors;
  msX, msY: Integer;
  draw: Boolean = true): Integer;
// returns the # of the item under the mouse cursor
var
  clipBuf: array [0..vClipOriginSaveBufSize] of Byte;
  c, ix, iy: Integer;
  mark, msOn: Boolean;
begin
  VSaveClipOrigin(clipBuf);

  result := -1;
  if topItem < 0 then topItem := 0;
  if itemsInRow < 1 then itemsInRow := 1;

  VFillRect(x, y, wChars*6+4+borderH*2, hChars*8+4+borderV*2, 255, outerFrameC);
  VFillRect(x+1, y+1, wChars*6+2+borderH*2, hChars*8+2+borderV*2, backC, frameC);
  Inc(x, 2+borderH); Inc(y, 2+borderV);

  c := 0; // current painting item
  while topItem < Length(items) do
  begin
    ix := x+(c mod itemsInRow)*rowWChars*6; iy := y+(c div itemsInRow)*8;
    if c div itemsInRow >= hChars then break;
    msOn := VPointInRect(msX, msY, ix, iy, rowWChars*6, 8);
    if msOn then result := topItem;
    if topItem < Length(markedItems) then mark := markedItems[topItem]
    else mark := false;
    DrawText(ix, iy, items[topItem],
      colors[mark, msOn, topItem=currentItem, 0],
      colors[mark, msOn, topItem=currentItem, 1]);

    Inc(topItem); Inc(c);
  end;

  VRestoreClipOrigin(clipBuf);
end;


initialization
  EmuDrawCursor := @MenuDrawCursor;
end.
