// DarkSpecter ZX Spectum Emulator
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
// process Win32 messages, run console
//
{.$DEFINE WRITE_MESSAGES}
unit dspEmuMsgU;

interface

uses
  Windows, Messages,  SysUtils, Classes, {$IFDEF WRITE_MESSAGES}wmsgu,{$ENDIF}
  lispCon3U,
  dspEmuVarsU, dspVScrU, dspEmuMiscU, dspEmuMouseU,
  dspMachineU, dspMachConstU, dspEmuU, dspWinU;


implementation


var
  conSaveCmd: TStringList;
  conCurCmd: Integer = 0;
  lastPartial: string = '';
  nextPartialN: Integer = -1;

  msgCatcher: function (var m: TMsg): Boolean = nil;
    // return TRUE if msg catched & we have to stop furhter handling


procedure DoConsoleCommandX ();
var
  s: string;
begin
  lastPartial := ''; nextPartialN := -1;

  s := emuConInputLine; emuConInputLine := '';
  if Trim(s) = '' then exit;

  nextPartialN := -1; lastPartial := '';

  if (conSaveCmd.Count < 1) or (conSaveCmd[conSaveCmd.Count-1] <> s) then
  begin
    conSaveCmd.Append(s);
    while conSaveCmd.Count > 256 do conSaveCmd.Delete(0);
  end;
  conCurCmd := conSaveCmd.Count;

  try
    ConExecute(s);
  except on e: Exception do
    WriteLn('***ERROR ', e.ClassName, ': ', e.Message);
  end;
end;

procedure Complete ();
var
  s: string;
begin
  if lastPartial = '' then
  begin
    lastPartial := emuConInputLine; nextPartialN := -1;
  end;

  s := ConFindPartialCommand(lastPartial, nextPartialN);
  if s = '' then
  begin
    lastPartial := ''; nextPartialN := -1; exit;
  end;

  emuConInputLine := s+' ';
end;

procedure ConPrevCommand ();
begin
  if conCurCmd = 0 then exit;
  Dec(conCurCmd);
  emuConInputLine := conSaveCmd[conCurCmd];
  lastPartial := ''; nextPartialN := -1;
end;

procedure ConNextCommand ();
begin
  if conCurCmd = conSaveCmd.Count then exit;
  Inc(conCurCmd);
  if conCurCmd = conSaveCmd.Count then emuConInputLine := ''
  else emuConInputLine := conSaveCmd[conCurCmd];
  lastPartial := ''; nextPartialN := -1;
end;

procedure ProcessConMessage (var msg: TMsg);
var
  ch: Char;
begin
  if not emuWConVisible then exit;
  if msg.message = WM_CHAR then
  begin
    ch := chr(msg.wparam and $FF);
    if ch = #13 then DoConsoleCommandX()
    else if ch = #8 then
    begin
      Delete(emuConInputLine, Length(emuConInputLine), 1);
      if (lastPartial <> '') and (Copy(emuConInputLine, 1, Length(lastPartial)) <> lastPartial) then
        begin lastPartial := ''; nextPartialN := -1; end;
    end
    else if ch = #9 then Complete()
    else if ch = ^Y then
    begin
      emuConInputLine := ''; lastPartial := ''; nextPartialN := -1;
    end
    else if ch = #27 then emuWConVisible := false
    else if ch = '`' then
    //else if ch >= ' ' then emuConInputLine := emuConInputLine+VStrAnsiToOem(ch);
    else if ch >= ' ' then
    begin
      emuConInputLine := emuConInputLine+ch;
      //lastPartial := ''; nextPartialN := -1;
    end;
    msg.message := 0;
  end
  else if msg.message = WM_KEYDOWN then
  begin
    msg.message := 0;
    case msg.wparam and $FFFF of
      VK_UP: ConPrevCommand();
      VK_DOWN: ConNextCommand();
    else msg.message := WM_KEYDOWN;
    end;
  end;
end;

procedure ProcessWinMessage (var msg: TMsg);
begin
  if msg.hwnd = emuHWnd then
  begin
    EmuProcessConMessage(msg);

    if (msg.message = WM_USER+1) then
    begin
      if conKeyBinds[msg.lParam and $07, msg.wParam and $FF] <> '' then
      begin
        try
          ConExecute(conKeyBinds[msg.lParam and $07, msg.wParam and $FF]);
        except on e: Exception do
          WriteLn('***ERROR ', e.ClassName, ': ', e.Message);
        end;
      end;
      hackZXSetProcs();
      //EmuResetTimers();
    end
    else
    begin
      if msg.message = WM_SYSKEYDOWN then msg.message := WM_KEYDOWN
      else if msg.message = WM_SYSKEYUP then msg.message := WM_KEYUP;
      //if msg.message = WM_KEYDOWN then WriteLn('>>KD before: ', msg.wParam);
      {$IFDEF WRITE_MESSAGES}
      WriteLn('++', WMsgFindByCode(msg.message),
        '; wParam: $', IntToHex(msg.wParam, 0),
        '; lParam: $', IntToHex(msg.lParam, 0));
      {$ENDIF}
    end;
    ZXWindowsMsg(msg);
  end;

  if msg.message <> 0 then
  begin
    TranslateMessage(msg);
    DispatchMessage(msg);
    emuQuit := emuQuit or (msg.message = WM_QUIT);
  end;
end;

procedure ProcessZXWinMessages ();
begin
end;

function ProcessMessages (): Boolean;
// true: WM_QUIT found
var
  msg: TMsg;
begin
  if emuTempPaused or emuPaused then Sleep(10);

  while PeekMessage(msg, 0, 0, 0, PM_REMOVE) do
  begin
    emuQuit := emuQuit or (msg.message = WM_QUIT);
    if Assigned(msgCatcher) then
    begin
      if msgCatcher(msg) then break;
    end;

    EmuProcessWinMessage(msg);
  end;
  ZXWindowsProcessMessages();
  result := emuQuit;
  //if not result then EmuProcessZXWinMessages();
end;


var
  wasMsg: Boolean;
  winMsg: TMsg;

function ReadKeyMsgCatcher (var msg: TMsg): Boolean;
begin
  //*if (msg.hwnd = emuHWnd) and (msg.message = WM_KEYDOWN) and (msg.wParam = VK_F12) then Halt(1);
  result := true; winMsg := msg; wasMsg := true;
  if msg.hwnd = emuHWnd then
  begin
    case msg.message of
      WM_QUIT, WM_CLOSE,
      WM_CHAR, WM_KEYDOWN, WM_KEYUP, WM_SYSKEYDOWN, WM_SYSKEYUP,
      WM_LBUTTONDOWN, WM_LBUTTONDBLCLK, WM_RBUTTONDOWN, WM_RBUTTONDBLCLK,
      WM_MOUSEMOVE, WM_MOUSEWHEEL: exit;
    end;
  end;
  wasMsg := false; result := false;
end;

function ReadKeyMouse (out msg: TMsg): Boolean;
begin
  msgCatcher := @ReadKeyMsgCatcher; wasMsg := false; msg.message := 0;
  try
    ProcessMessages();

    result := wasMsg; if wasMsg then msg := winMsg;
  finally
    msgCatcher := nil;
  end;
end;


initialization
  conSaveCmd := TStringList.Create();
  EmuProcessMessages := @ProcessMessages;
  EmuReadKeyMouse := @ReadKeyMouse;
  EmuProcessWinMessage := @ProcessWinMessage;
  EmuProcessConMessage := @ProcessConMessage;
finalization
  conSaveCmd.Free();
end.
