;(setq lasm_misc *t*)
;  

(defun bad-syntax (msg)  (throw lasm-line-n msg))

(defun trim (str) (trim-str str))  ; alias %-)

(defun lo-case-code (n)
;  .    
;   !
  (if (land (>= n 65) (<= n 90)) (+ n 32)  n)
)

(defun lo-case (ch)
;     
  (chr (lo-case-code (nth ch 1)))
)

;  is-XXX      NIL,   
(defun is-space (ch)
; NIL --  !
  (within ch 1 32)
)

(defun is-colon (ch)
  (= ch 58)
)

(defun is-comma (ch)
  (= ch 44)
)

(defun is-quote (ch)
; "
  (= ch 34)
)

(defun is-nquote (ch)
; not "
  (<> ch 34)
)

(defun is-alpha (ch)
; "_" is the ALPHA TOO!
  (lor (within (lo-case-code ch) 97 122)  (= ch 95))
)

(defun is-number (ch)
  (within ch 48 57)
)

(defun is-alphanum (ch)
  (lor (is-alpha ch) (is-number ch))
)

(defun is-eol (ch)
; NIL -- EOL flag
  (= ch 0)
)


;    
(defun smart-locase (str | x res)
  (setq res "")
  (while (not-empty-str? str)
    ; skip quotes
    (while (land (not-empty-str? str) (is-quote (nth str 1)))
      (setq x 2)
      (while (land (<= x (length str))  (<> (nth str x) 34))  (setq x (incr x)))
      (setq res (|| res (str-mid str 1 x))
            str (str-mid str (incr x)))
    )
    ; lower other
    (setq x 1)
    (while (land (<= x (length str))  (<> (nth str x) 34))  (setq x (incr x)))
    (if (> x 1)  (setq res (|| res (lower-case (str-mid str 1 (decr x))))
                       str (str-mid str x))
    )
  )
  res
)

(defun lasm-norm-byte (b)
  (if
    (within b -128 -1) (+ 256 b)
    ;(within b 0 255) b
   ;(bad-syntax (|| "byte value out of range: " (tostr b)))
   (& b 255)
  )
)

(defun lasm-norm-word (w)
  (if
    (within w -32768 -1) (+ 65536 w)
    ;(within w 0 65535) w
   ;(bad-syntax (|| "byte value out of range: " (tostr b)))
   (& w 65535)
  )
)
