// DarkSpecter ZX Spectum Emulator
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
// simple and slow UTF8 procedures v0.0.1
//
unit utf8U;

interface


function UTF8EncodeANSI (const s: string): string;
function UTF8Encode (const ws: WideString): string;
function UTF8Decode (const s: string): WideString;
function UTF8DecodeANSI (const s: string): string;
function UTF8Length (const s: string): Integer;


implementation


function UTF8Encode (const ws: WideString): string;
var
  f: Integer;
begin
  result := '';
  for f := 1 to Length(ws) do
  begin
    if ord(ws[f]) < 128 then result := result+ws[f]
    else if ord(ws[f]) < 2048 then
    begin
      result := result+chr(ord(ws[f]) div 64+192);
      result := result+chr(ord(ws[f]) mod 64+128);
    end
    else
    begin
      result := result+chr(ord(ws[f]) div 4096+224);
      result := result+chr(ord(ws[f]) div 64 mod 64+128);
      result := result+chr(ord(ws[f]) mod 64+128);
    end;
  end;
end;

function UTF8EncodeANSI (const s: string): string;
var
  ws: WideString;
begin
  ws := s; result := UTF8Encode(ws);
end;

function UTF8Length (const s: string): Integer;
var
  f: Integer;
begin
  f := 1; result := 0;
  while f <= Length(s) do
  begin
    if ord(s[f]) < 128 then
    begin
      Inc(result); Inc(f);
    end
    else if ord(s[f]) < 224 then
    begin
      if f >= Length(s) then break; // ignore bad charz
      Inc(result); Inc(f, 2);
    end
    else
    begin
      if f >= Length(s)-1 then break; // ignore bad charz
      Inc(result); Inc(f, 3);
    end;
  end;
end;

function UTF8Decode (const s: string): WideString;
var
  wc: WideChar;
  f, cc: Integer;
begin
  f := 1; result := '';
  while f <= Length(s) do
  begin
    if ord(s[f]) < 128 then
    begin
      cc := ord(s[f]); Inc(f);
    end
    else if ord(s[f]) < 224 then
    begin
      if f >= Length(s) then break; // ignore bad charz
      if ord(s[f+1]) >= 128 then cc := (ord(s[f])-192)*64+ord(s[f+1])-128
      else cc := 95;
      Inc(f, 2);
    end
    else
    begin
      if f >= Length(s)-1 then break; // ignore bad charz
      if (ord(s[f+1]) >= 128) and (ord(s[f+2]) >= 128) then
        cc := ((ord(s[f])-224)*64+ord(s[f+1])-128)*64+ord(s[f+2])-128
      else cc := 95;
      Inc(f, 3);
    end;
    Move(cc, wc, 2); //!!!nonstandard!
    result := result+wc;
  end;
end;

function UTF8DecodeANSI (const s: string): string;
begin
  result := UTF8Decode(s);
end;


end.
